#!/usr/bin/env python3

import predict
import keras.models
import scipy.misc
from os.path import join
import os.path
import sys

model_path = join(os.path.dirname(os.path.abspath(__file__)), 'trained_'+sys.argv[1]+'.h5')
filepath = 'input_0.png'
prediction_path = 'output_(:i).png'

config = __import__('crack_merged', fromlist=[''])

print ('Loading models')
model = keras.models.load_model(model_path)

o_im_np = scipy.misc.imread(filepath)

preds_np = []

for ratio in [1, 0.5, 0.25, 0.125]:
    im_np = o_im_np
    if (ratio < 1):
        im_np = scipy.misc.imresize(im_np, ratio)
    _im_np, pred_np = predict.predict_data(model, config, im_np)
    pred_np = (pred_np[:,:,0] * 255).astype('uint8')
    print (pred_np.shape, im_np.shape)
    pred_np = pred_np[:im_np.shape[0], :im_np.shape[1]]
    if (pred_np.shape[0] != o_im_np.shape[0] or pred_np.shape[1] != o_im_np.shape[1]):
        pred_np = scipy.misc.imresize(pred_np, o_im_np.shape[:2])
    preds_np.append(pred_np)
    
for i in range(len(preds_np)):
    scipy.misc.imsave(prediction_path.replace('(:i)', str(i)), preds_np[i])